Bug 765192 - (GLUSTER-3460) [glusterfs-3.3.0qa6]: glusterd crashed upon volume set help
[glusterfs-3.3.0qa6]: glusterd crashed upon volume set help
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: glusterd (Show other bugs)
pre-release
x86_64 Linux
medium Severity high
: ---
: ---
Assigned To: Vijay Bellur
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-08-22 05:03 EDT by Raghavendra Bhat
Modified: 2011-08-29 03:45 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions: glusterfs-3.3beta
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Anand Avati 2011-08-22 02:50:28 EDT
CHANGE: http://review.gluster.com/295 (Change-Id: I84b4f7c9c2787334ce67e5c3e0534953b691c8e0) merged in master by Vijay Bellur (vijay@gluster.com)
Comment 1 Raghavendra Bhat 2011-08-22 05:03:10 EDT
glusterd crashed when gluster volume set help command was issued. This is the backtrace of the core generated.

Core was generated by `glusterd'.
Program terminated with signal 11, Segmentation fault.
#0  0x00000030b8e9e8a7 in internal_fnmatch () from /lib64/libc.so.6
(gdb) bt
#0  0x00000030b8e9e8a7 in internal_fnmatch () from /lib64/libc.so.6
#1  0x00000030b8ea24d5 in fnmatch@@GLIBC_2.2.5 () from /lib64/libc.so.6
#2  0x00002b829baa9ad5 in xlator_volume_option_get_list (vol_list=0x7fff74b491f0, key=0x2aaaaab3266a "data-self-heal-window-size")
    at ../../../libglusterfs/src/options.c:589
#3  0x00002b829baaa4c7 in xlator_option_info_list (list=0x7fff74b491f0, key=0x2aaaaab3266a "data-self-heal-window-size", 
    def_val=0x7fff74b491e0, descr=0x7fff74b491d8) at ../../../libglusterfs/src/options.c:840
#4  0x00002aaaaab1dae4 in glusterd_get_volopt_content (xml_out=_gf_false) at ../../../../../xlators/mgmt/glusterd/src/glusterd-volgen.c:1796
#5  0x00002aaaaaaf4ebc in glusterd_volset_help (dict=0x4961b20) at ../../../../../xlators/mgmt/glusterd/src/glusterd-op-sm.c:5670
#6  0x00002aaaaaaf509e in glusterd_op_set_volume (dict=0x4961b20) at ../../../../../xlators/mgmt/glusterd/src/glusterd-op-sm.c:5707
#7  0x00002aaaaaafac58 in glusterd_op_commit_perform (op=GD_OP_SET_VOLUME, dict=0x4961b20, op_errstr=0x7fff74b493c8, rsp_dict=0x0)
    at ../../../../../xlators/mgmt/glusterd/src/glusterd-op-sm.c:7782
#8  0x00002aaaaaaf8866 in glusterd_op_ac_send_commit_op (event=0x4961a50, ctx=0x4961900)
    at ../../../../../xlators/mgmt/glusterd/src/glusterd-op-sm.c:6952
#9  0x00002aaaaaafc502 in glusterd_op_sm () at ../../../../../xlators/mgmt/glusterd/src/glusterd-op-sm.c:8642
#10 0x00002aaaaab0d23e in glusterd3_1_stage_op_cbk (req=0x2aaaab186044, iov=0x2aaaab186084, count=1, myframe=0x2b829cc160cc)
    at ../../../../../xlators/mgmt/glusterd/src/glusterd-rpc-ops.c:1154
#11 0x00002b829bce6fde in rpc_clnt_handle_reply (clnt=0x4966720, pollin=0x4961650) at ../../../../rpc/rpc-lib/src/rpc-clnt.c:747
#12 0x00002b829bce7315 in rpc_clnt_notify (trans=0x49668d0, mydata=0x4966750, event=RPC_TRANSPORT_MSG_RECEIVED, data=0x4961650)
    at ../../../../rpc/rpc-lib/src/rpc-clnt.c:860
#13 0x00002b829bce39fb in rpc_transport_notify (this=0x49668d0, event=RPC_TRANSPORT_MSG_RECEIVED, data=0x4961650)
    at ../../../../rpc/rpc-lib/src/rpc-transport.c:498
#14 0x00002aaaaadf6ea7 in socket_event_poll_in (this=0x49668d0) at ../../../../../rpc/rpc-transport/socket/src/socket.c:1676
#15 0x00002aaaaadf73e9 in socket_event_handler (fd=9, idx=3, data=0x49668d0, poll_in=1, poll_out=0, poll_err=0)
    at ../../../../../rpc/rpc-transport/socket/src/socket.c:1791
#16 0x00002b829ba9164c in event_dispatch_epoll_handler (event_pool=0x494f920, events=0x495bf90, i=0) at ../../../libglusterfs/src/event.c:794
#17 0x00002b829ba91851 in event_dispatch_epoll (event_pool=0x494f920) at ../../../libglusterfs/src/event.c:856
#18 0x00002b829ba91bab in event_dispatch (event_pool=0x494f920) at ../../../libglusterfs/src/event.c:956
#19 0x0000000000407222 in main (argc=1, argv=0x7fff74b4a258) at ../../../glusterfsd/src/glusterfsd.c:1557
(gdb)  f 2
#2  0x00002b829baa9ad5 in xlator_volume_option_get_list (vol_list=0x7fff74b491f0, key=0x2aaaaab3266a "data-self-heal-window-size")
    at ../../../libglusterfs/src/options.c:589
589                             if (fnmatch (cmp_key, key, FNM_NOESCAPE) == 0) {
(gdb) l
584             for (index = 0; opt[index].key && opt[index].key[0]; index++) {
585                     for (i = 0; i < ZR_VOLUME_MAX_NUM_KEY; i++) {
586                             cmp_key = opt[index].key[i];
587                             if (!cmp_key)
588                                     break;
589                             if (fnmatch (cmp_key, key, FNM_NOESCAPE) == 0) {
590                                     found = &opt[index];
591                                     goto out;
592                             }
593                     }
(gdb) p opt[index]
$3 = {key = {0xf00d00746e756f63 <Address 0xf00d00746e756f63 out of bounds>, 0xbaad <Address 0xbaad out of bounds>, 0x0, 
    0x41 <Address 0x41 out of bounds>}, type = 38, min = 330247113495543808, max = -3819410108757049344, value = {0x0, 
    0xadf00d00706c6568 <Address 0xadf00d00706c6568 out of bounds>, 0xba <Address 0xba out of bounds>, 0x0, 
    0x61 <Address 0x61 out of bounds>, 0x2800000002 <Address 0x2800000002 out of bounds>, 
    0x495460000000000 <Address 0x495460000000000 out of bounds>, 0xcafebabe00000000 <Address 0xcafebabe00000000 out of bounds>, 0x0, 
    0x495cbf0 "", 0x495ce00 "\320̕\004", 0x495cbf0 "", 0x495ea00 "", 0x495cd30 "help", 0xbaadf00d <Address 0xbaadf00d out of bounds>, 0x0, 
    0x41 <Address 0x41 out of bounds>, 0x50000002d <Address 0x50000002d out of bounds>, 
    0x495460000000000 <Address 0x495460000000000 out of bounds>, 0xcafebabe00000000 <Address 0xcafebabe00000000 out of bounds>, 0x0, 
    0xadf00d00706c6568 <Address 0xadf00d00706c6568 out of bounds>, 0xba <Address 0xba out of bounds>, 0x0, 
    0x51 <Address 0x51 out of bounds>, 0x2000000003 <Address 0x2000000003 out of bounds>, 
    0x495460000000000 <Address 0x495460000000000 out of bounds>, 0xcafebabe00000000 <Address 0xcafebabe00000000 out of bounds>, 0x0, 
    0x500000000 <Address 0x500000000 out of bounds>, 0x0, 0x495cdc0 "help", 0x100000003 <Address 0x100000003 out of bounds>, 
    0xbaadf00d <Address 0xbaadf00d out of bounds>, 0x41 <Address 0x41 out of bounds>, 0x500000026 <Address 0x500000026 out of bounds>, 
    0x495460000000000 <Address 0x495460000000000 out of bounds>, 0xcafebabe00000000 <Address 0xcafebabe00000000 out of bounds>, 0x0, 
    0xadf00d00706c6568 <Address 0xadf00d00706c6568 out of bounds>, 0xba <Address 0xba out of bounds>, 0x0, 
    0x61 <Address 0x61 out of bounds>, 0x2800000002 <Address 0x2800000002 out of bounds>, 
    0x495460000000000 <Address 0x495460000000000 out of bounds>, 0xcafebabe00000000 <Address 0xcafebabe00000000 out of bounds>, 0x0, 
    0x495ccd0 "\360˕\004", 0x0, 0x495ccd0 "\360˕\004", 0x495cd70 "", 0x495ce60 "volname", 0xbaadf00d <Address 0xbaadf00d out of bounds>, 
    0x0, 0x41 <Address 0x41 out of bounds>, 0x80000002d <Address 0x80000002d out of bounds>, 
    0x495460000000000 <Address 0x495460000000000 out of bounds>, 0xcafebabe00000000 <Address 0xcafebabe00000000 out of bounds>, 0x0, 
    0x656d616e6c6f76 <Address 0x656d616e6c6f76 out of bounds>, 0xbaadf00d <Address 0xbaadf00d out of bounds>, 0x0, 
    0x61 <Address 0x61 out of bounds>, 0x2800000002 <Address 0x2800000002 out of bounds>}, 
  default_value = 0x495460000000000 <Address 0x495460000000000 out of bounds>, 
  description = 0xcafebabe00000000 <Address 0xcafebabe00000000 out of bounds>}
(gdb) p cmp_key
$4 = 0xf00d00746e756f63 <Address 0xf00d00746e756f63 out of bounds>
(gdb)  f 3
#3  0x00002b829baaa4c7 in xlator_option_info_list (list=0x7fff74b491f0, key=0x2aaaaab3266a "data-self-heal-window-size", 
    def_val=0x7fff74b491e0, descr=0x7fff74b491d8) at ../../../libglusterfs/src/options.c:840
840             opt = xlator_volume_option_get_list (list, key);
(gdb) p key
$5 = 0x2aaaaab3266a "data-self-heal-window-size"
(gdb)
Comment 2 Anand Avati 2011-08-23 02:00:50 EDT
CHANGE: http://review.gluster.com/310 (Change-Id: I1649ed61b13b935d714ca024e6883f3903c5edeb) merged in master by Vijay Bellur (vijay@gluster.com)
Comment 3 Raghavendra Bhat 2011-08-29 00:45:56 EDT
This is fixed and volume set help is not crashing.

Note You need to log in before you can comment on or make changes to this bug.